package com.syc.slm.slmbi.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.syc.slm.slmbi.dto.InstrumentPanelAssemblyDTO;
import com.syc.slm.slmbi.entity.InstrumentPanel;
import com.syc.slm.slmbi.entity.InstrumentPanelTree;
import lombok.NonNull;

import java.util.List;
import java.util.Set;

/**
 * 仪表板树聚合表
 *
 * @author lin
 * @date 2021-04-01 10:52:44
 */
public interface InstrumentPanelTreeService extends IService<InstrumentPanelTree> {

    void batchUpdateTreeByIds(Set<String> treeIds, Integer recordStatus);

    /**
     * 初始化仪表板树
     *
     * @param nodeId
     * @param nodeType
     * @param bizId
     * @param bizName
     */
    void initTree(String nodeId, String nodeType, String bizId, String bizName);

    /**
     * 根据仪表板id删除仪表板树
     *
     * @param panelId
     */
    void delTreeByPanelId(String panelId);

    /**
     * 根据仪表板详情保存仪表板组件树
     *
     * @param tree
     * @param assembly
     * @param panelId
     */
    void savePanelAssemblyTree(InstrumentPanelTree tree, List<InstrumentPanelAssemblyDTO> assembly, String panelId);

    /**
     * 根据fullId 删除仪表板树
     * @param fullId
     */
    void delTreeByPanelFullId(String fullId);

    /**
     * 更新仪表板树
     * @param panelId
     * @param panelName
     * @param groupId
     */
    void updatePanelTreeFullName(String panelId,String panelName,String groupId) ;
}
