package com.syc.slm.slmbi.service.impl;

import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.google.common.collect.Sets;
import com.google.gson.reflect.TypeToken;
import com.syc.slm.common.core.constant.SlmConstants;
import com.syc.slm.slmbi.dao.InstrumentPanelDraftMapper;
import com.syc.slm.slmbi.entity.BaseEntity;
import com.syc.slm.slmbi.entity.InstrumentPanel;
import com.syc.slm.slmbi.entity.InstrumentPanelDraft;
import com.syc.slm.slmbi.service.InstrumentPanelDraftService;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * 仪表板草稿
 *
 * @author lin
 * @date 2021-04-01 10:52:44
 */
@Service
public class InstrumentPanelDraftServiceImpl extends ServiceImpl<InstrumentPanelDraftMapper, InstrumentPanelDraft>
    implements InstrumentPanelDraftService {

    @Override
    public void saveDrafts(List<InstrumentPanel> panels) {
        if(CollectionUtils.isNotEmpty(panels)){
            List<InstrumentPanelDraft> drafts= SlmConstants.gson.fromJson(SlmConstants.gson.toJson(panels),
                                                  new TypeToken<List<InstrumentPanelDraft>>() {
                                                  }.getType());
            List<InstrumentPanelDraft> panelDrafts = baseMapper.selectBatchIds(panels.stream()
                                                                               .map(InstrumentPanel::getId)
                                                                               .collect(Collectors.toList()));
           Set<String> idSets= CollectionUtils.isNotEmpty(panelDrafts)?panelDrafts.stream().map(BaseEntity::getId).collect(Collectors.toSet()): Sets.newHashSet();
            drafts.forEach(x->{
                if(idSets.contains(x.getId())){
                    baseMapper.updateById(x);
                }else{
                    baseMapper.insert(x);
                }
            });
        }
    }
}
